.;	MCR INS $IPP
.;	ipp tie=tie
.;	MCR REM IPP
.ENABLE SUBSTITUTION
.DISABLE DISPLAY
.ENABLE ESCAPE
.ENABLE CONTROL-Z
.ENABLE ATTACH
.ENABLE DETACH
.;
.; 								W. Dwyne
.;
.;	Istructions for useing are found in [1,2]TIE.HLP
.;
.;	.ONERR INDERR !				Catch any ind errors
	.SETS PIP "TIP" !			Allows the use of an alternate
	.;					name for PIP
	.SETS DISK "'<SYDISK>''<SYUNIT>':" !	The default disk
	.SETT NAMED !				Default to named directories
	.;
	.SETS UIC <DIRECT> !			If in named directory mode this
	.;					will be the UIC from which we 
	.;					were requested .
	.;
	.IF UIC EQ "[]" .SETF NAMED !	 	Not in named directory mode
	.IF UIC EQ "[]" .SETS UIC <UIC> ! 	Not a named directory get the 
	.;					UIC.
	.SETS ORGUIC UIC !			Ditto but will not be modified
	.SETF CNAMED !				Indicates a change to named
	.;					directories
	.SETF SUB !				Default setting. Not subroutine.
	.SETF CHGUIC !				Indiactes that the uic was not
	.;					changed
	.SETF COMWRN !				Indicates compiler encountered
	.;					warnings
	.SETF COMOK !				Indicator for compiler success
	.;					or failure
	.SETF TKBOK !				Indicator fir TKB success or 
	.;					failure
	.SETF BAT !				Default for batch mode F
	.SETT MCR !				Default for MCR command optionm
	.SETT ASKHIM !				Used to conditionally issue .ASK
	.SETF LISTNO !				Used to suppress listing file
	.SETF LSTYES !				Used to include listing file
	.SETT PIPOK !
	.SETT INSOK !
	.SETF RUNING !				Used to indicate that the task
	.;					being built is active.
	.SETS NOTINS "NOT" !			Indicates task not installled
	.SETS APROG "" !			The name (if any) of the 
	.;					active task.
	.SETS LISTD "" !			Default list device
	.SETN STATUS 4 !			Default exit stat severe error
	.SETN LCNT 0 !				Line counter
	.SETN MAX 35 !				Max # of lines to check for
	.;					compiler TKB & MCR instructions.
	.;
	.;       S e t   u p   f o r   T K B   I D E N T   s w i t c h
	.;
	.SETS TODAY "'<DATE>'" !		Todays date.
	.SETS DAY TODAY[1:2] !			Parse out the day
	.SETS FIRMON TODAY[4:4] !		Parse out first char of month.
	.SETS LSTMON TODAY[6:6] !		Parse out last char of month.
	.SETS YEAR TODAY[8.:9.] !		Parse out year
	.SETS AIDENT "'DAY''FIRMON''LSTMON''YEAR'" ! Actual ident

	.; 	S e t   u p   t h e   f o u r   d i g i t   y e a r
	.;
	.SETN NYEAR 'YEAR'. !				Make numeric
	.SETN NYEAR 1900.+'YEAR'. !			Add the century
	.IF NYEAR LT 1950. .SETN NYEAR 2000+'YEAR' !	Must be next century
	.SETS YEAR "'NYEAR'" !				Back to string
	.SETS TODAY TODAY[1:7]+YEAR
	.;
	.;       S e t   u p   f o r   t e r m i n a l   t y p e s
	.;
	.IF <TITYPE> EQ 36 .GOTO V100 !		Terminal is a VT2xx
	.IF <TITYPE> NE 15 .GOTO NOV100 !	Terminal is not a VT100 
.V100:	.SETS HOMCLR "[0;0H[0J" !	Clear and home for VT100
	.SETS BOLD "[1m" !			Bold
	.SETS ATTOFF "[0m" !		All attributes off
	.GOTO TERMOK
.NOV100:.;
	.IF <TITYPE> NE 11 .GOTO NOVT52 !	Terminal is not a VT52
	.SETS HOMCLR "HJ" !		Clear and home for VT52
	.SETS BOLD "" !				Bold ( not on VT52 )
	.SETS ATTOFF "" !			All attributes off (Not on VT52)
	.GOTO TERMOK
.;
.NOVT52:.;
	.SETS HOMCLR "" !			Presume no CRT
	.SETS BOLD "" !				Bold not set
	.SETS ATTOFF "" !			Attributes off not set
	.;
.TERMOK:.;
	.;
	.SETS FOR "FOR" !			For FORTRAN IV compiler
	.SETS COMP1 "'FOR'" !			Compiler # 1
	.SETS TYPE1 "FTN" ! 			File extension type for
	.;					compiler # 1
	.SETS TYPE1A "SUB" !			Alternate file extension for
	.;					compiler # 1
	.;
	.SETS F77 "F77" !			For Fortran 77 compiler
	.SETS COMP2 "'F77'" !			Compiler # 2
	.SETS TYPE2 "F77" !			File extension type for 
	.;					compiler # 2
	.;
	.SETS XCC "XCC" !			For C compiler
	.SETS COMP3 "'XCC'" !			Compiler # 3
	.SETS TYPE3 "C" !			File extension type for 
	.;					compiler # 3
	.;
	.SETS MAC "MAC" !			For MACRO compiler
	.SETS COMP4 "'MAC'" !			Compiler # 4
	.SETS TYPE4 "MAC" !			File extension type for 
	.;					compiler # 4

	.SETS IPP "IPP" !			For INDIRECT compiler
	.SETS COMP5 "'IPP'" !			Compiler # 5
	.SETS TYPE5 "CMD" !			File extension type for 
	.;					compiler # 5
	.;
	.;
	.DISABLE LOWERCASE
	.;
	.;              S e t   u p   c o m p l e t e
	.;
	.;		D i s p l a y   h e a d i n g s
	.;
	; 'HOMCLR'
	;TIE V7.6					'BOLD''<TIME>'   'TODAY'   '<NETNOD>''ATTOFF'
	.;
	.; Check to see if the file name has been passed by TIE.FTN or 
	.; TIE.CMD if not ask for it.
	.;
	.IF P1 EQ "?" .GOTO HELP
	.SETS PROG "'P1'"
	.;
	.IF PROG NE "" .GOTO GOTNAM !			Program name passed in.
	.IFF ASKHIM .GOTO END !				No name + NOASK = Stop
	.;
	.ASKS [1:20:" ":1M] PROG Whats the name of your source program > 
	.IFT <EOF> .GOTO END
	.GOTO NOOPT !					No options allowed
	.;
.GOTNAM:;File>'P1'	Options> 'P2'	'P3'	'P4'	'P5'
	.;
	.;	C h e c k   f o r   p a s s e d   i n   p a r a m e t e r s
	.;
	.;
	.;  Check to see if the P2-P5 parameter is a NO?.
	.;
	.IF P2 EQ ""  .GOTO NOOPT !			No P2 options entered

	.IF P2 EQ "NOASK"  .SETF ASKHIM !		No ASK reqested
	.IF P2 EQ "NOASK"  .GOTO P3 !	

	.IF P2 EQ "NOLIST" .SETT LISTNO !		No LIST requested
	.IF P2 EQ "NOLIST" .GOTO P3 !	

	.IF P2 EQ "LIST" .SETT LSTYES !			LIST requested
	.IF P2 EQ "LIST"  .GOTO P3 !	

	.IF P2 EQ "NOMCR"  .SETF MCR !			No MCR requested
	.IF P2 EQ "NOMCR"  .GOTO P3 !	

	.IF P2 EQ "NOPIP"  .SETF PIPOK !		No PIP requested
	.IF P2 EQ "NOPIP"  .GOTO P3 !	

	.IF P2 EQ "NOINS"  .SETF INSOK !		No INS requested
	.IF P2 EQ "NOINS"  .GOTO P3 !

	.IF P2 EQ "NOTKB"  .SETT SUB !			Treat NOTKB like .sub
	.IF P2 EQ "NOTKB"  .GOTO P3 !

	.IF P2 EQ "BATCH"  .SETT BAT !			Batch mode requested
	.IFT BAT .SETS P2 "" !				So batch does not repeat
	.IFT BAT .GOTO P3 !
	;						Option 'BOLD''P2''ATTOFF' is invalid
	.;
.P3:	.IF P3 EQ ""  .GOTO NOOPT !			No P3 options entered

	.IF P3 EQ "NOASK"  .SETF ASKHIM !		No ASK reqested
	.IF P3 EQ "NOASK"  .GOTO P4 !	

	.IF P3 EQ "NOLIST" .SETT LISTNO !		No LIST requested
	.IF P3 EQ "NOLIST"  .GOTO P4 !	

	.IF P3 EQ "LIST" .SETT LSTYES !			LIST requested
	.IF P3 EQ "LIST"  .GOTO P4 !	

	.IF P3 EQ "NOMCR"  .SETF MCR !			No MCR requested
	.IF P3 EQ "NOMCR"  .GOTO P4 !	

	.IF P3 EQ "NOPIP"  .SETF PIPOK !		No PIP requested
	.IF P3 EQ "NOPIP"  .GOTO P4 !	

	.IF P3 EQ "NOINS"  .SETF INSOK !		No INS requested
	.IF P3 EQ "NOINS"  .GOTO P4 !

	.IF P3 EQ "NOTKB"  .SETT SUB !			Treat NOTKB like .sub
	.IF P3 EQ "NOTKB"  .GOTO P4 !

	.IF P3 EQ "BATCH"  .SETT BAT !			Batch mode requested
	.IFT BAT .SETS P3 "" !				So batch does not repeat
	.IFT BAT .GOTO P4 !
	;						Option 'BOLD''P3''ATTOFF' is invalid
	.;
.P4:	.IF P4 EQ ""  .GOTO NOOPT !			No P4 options entered

	.IF P4 EQ "NOASK"  .SETF ASKHIM !		No ASK reqested
	.IF P4 EQ "NOASK"  .GOTO P5 !	

	.IF P4 EQ "NOLIST" .SETT LISTNO !		No LIST requested
	.IF P4 EQ "NOLIST"  .GOTO P5 !	

	.IF P4 EQ "LIST" .SETT LSTYES !			LIST requested
	.IF P4 EQ "LIST"  .GOTO P5 !	

	.IF P4 EQ "NOMCR"  .SETF MCR !			No MCR requested
	.IF P4 EQ "NOMCR"  .GOTO P5 !	

	.IF P4 EQ "NOPIP"  .SETF PIPOK !		No PIP requested
	.IF P4 EQ "NOPIP"  .GOTO P5 !	

	.IF P4 EQ "NOINS"  .SETF INSOK !		No INS requested
	.IF P4 EQ "NOINS"  .GOTO P5 !

	.IF P4 EQ "NOTKB"  .SETT SUB !			Treat NOTKB like .sub
	.IF P4 EQ "NOTKB"  .GOTO P5 !

	.IF P4 EQ "BATCH"  .SETT BAT !			Batch mode requested
	.IFT BAT .SETS P4 "" !				So batch does not repeat
	.IFT BAT .GOTO P5 !
	;						Option 'BOLD''P4''ATTOFF' is invalid
	.;
.P5:	.IF P5 EQ ""  .GOTO NOOPT !			No P5 options entered

	.IF P5 EQ "NOASK"  .SETF ASKHIM !		No ASK reqested
	.IF P5 EQ "NOASK"  .GOTO NOOPT !	

	.IF P5 EQ "NOLIST" .SETT LISTNO !		No LIST requested
	.IF P5 EQ "NOLIST"  .GOTO NOOPT !	

	.IF P5 EQ "LIST" .SETT LSTYES !			LIST requested
	.IF P5 EQ "LIST"  .GOTO NOOPT !	

	.IF P5 EQ "NOMCR"  .SETF MCR !			No MCR requested
	.IF P5 EQ "NOMCR"  .GOTO NOOPT !	

	.IF P5 EQ "NOPIP"  .SETF PIPOK !		No PIP requested
	.IF P5 EQ "NOPIP"  .GOTO NOOPT !	

	.IF P5 EQ "NOINS"  .SETF INSOK !		No INS requested
	.IF P5 EQ "NOINS"  .GOTO NOOPT !

	.IF P5 EQ "NOTKB"  .SETT SUB !			Treat NOTKB like .sub
	.IF P5 EQ "NOTKB"  .GOTO NOOPT !

	.IF P5 EQ "BATCH"  .SETT BAT !			Batch mode requested
	.IFT BAT .SETS P5 "" !				So batch does not repeat

	;						Option 'BOLD''P5''ATTOFF' is invalid
	.;
.NOOPT:	.;
	.ENABLE QUIET
	.IF PIP NE "PIP" .IFNINS 'PIP' INS $PIP/TASK=...'PIP' !
	.;						'PIP' is PIP used by
	.;						this this program. This
	.;						allows for the
	.;						concurent use of PIP
	.DISABLE QUIET
	.;
	.;
	.;  C h e c k   f o r   a   d e v i c e   s p e c i f i c a t i o n
	.;
	.PARSE PROG ":" NEWDEV BALANC !			Check for a device on
	.;						the input line
	.;
	.IF BALANC EQ "" .GOTO NODEV !			Device was not entered.
	.SETS PROG "'BALANC'" !				Device was entered 
	.;						modify default.
	.SETS DISK "'NEWDEV':"
	.;
.NODEV:	.;
	.;
	.;      C h e c k   f o r   a   U I C   s p e c i f i c a t i o n
	.;
	.PARSE PROG "]" NEWUIC BALANC !			Check for a UIC on the
	.;						input line
	.IF BALANC EQ "" .GOTO NOUIC !	 		UIC was not entered
	.SETS PROG "'BALANC'" ! 			UIC was entered modify
	.;						default
	.SETS UIC "'NEWUIC']"
	.PARSE UIC "," GROUP MEMBER !			Member will be "" if
	.;						a named directory was
	.;						passed in.
	.IFF NAMED .AND .IF MEMBER EQ "" .GOTO SWIDIR
	.GOTO DEFUIC
.SWIDIR:.;						Switch to named
	.;						directories
	.SETT NAMED
	.SETT CNAMED
	.DISABLE QUIET
	;						'BOLD'Switch to named directories'ATTOFF'
	.ENABLE QUIET
	SET /NAMED
	.;
.DEFUIC:SET /DEF = 'UIC'
	.;						Change default for 
	.;						terminal, this will 
	.;						allow programs that do
	.;						not have the uic in
	.;						the compiler and TKB
	.;						instructions to work
	.;						properly.
	.;
	.SETT CHGUIC !					UIC has been changed
	.;
	.DISABLE QUIET
	.;						Report change of uic
	;						'BOLD'Uic >'<DIRECT>' prot >'<UIC>''ATTOFF'
	.;
	.;
.NOUIC:	.;
	.;
	.;
	.;
	.; Was the program name entered with an extension ie prog.ftn
	.;
	.;
	.PARSE PROG "." FILE EXT !			Check for a file
	.;						extension
	.;
	.SETS PROG "'FILE'"
	.SETS NAME "'FILE'"
	.SETS TYPE "'EXT'"
	.;
	.IF EXT EQ "" .SETS TYPE "'TYPE1'" !		No file extension was
	.;						entered.
	.;
	.IF EXT EQ "SUB" .SETT SUB !			It's a subroutine no 
	.;						tkb required
	.IF EXT EQ TYPE5 .SETT SUB !			Treat indirect like .sub
	.;
	.;                T e s t   f o r   v a l i d   f i l e
	.;
	.TESTFILE  'DISK''UIC''PROG'.'TYPE' !
	.IF <FILERR> NE 1 .GOTO TYPE1A !		File not found
	.GOTO OKFILE !					File found ok
	.;
.TYPE1A:.IF EXT NE "" .GOTO NOFILE !			Extension passed but
	.;						no file exists - exit,
	.;
	.;						Check the alternate
	.;						file extension.
	.TESTFILE 'DISK''UIC''PROG'.'TYPE1A' !
	.IF <FILERR> NE 1 .GOTO TYPE2 !			File not found
	.SETS TYPE "'TYPE1A'"
	.GOTO OKFILE !					File found ok
	.;
.TYPE2:	.;
	.TESTFILE 'DISK''UIC''PROG'.'TYPE2' !
	.IF <FILERR> NE 1 .GOTO TYPE3 !			File not found
	.SETS TYPE "'TYPE2'"
	.GOTO OKFILE !					File found ok
	.;
.TYPE3:	.;
	.TESTFILE 'DISK''UIC''PROG'.'TYPE3' !
	.IF <FILERR> NE 1 .GOTO TYPE4 !			File not found
	.SETS TYPE "'TYPE3'"
	.GOTO OKFILE !					File found ok
	.;
.TYPE4:	.;
	.TESTFILE 'DISK''UIC''PROG'.'TYPE4' !
	.IF <FILERR> NE 1 .GOTO TYPE5 !			File not found
	.SETS TYPE "'TYPE4'"
	.GOTO OKFILE !					File found ok
	.;
.TYPE5:	.;
	.TESTFILE 'DISK''UIC''PROG'.'TYPE5' !
	.IF <FILERR> NE 1 .GOTO NOFILE !		File not found
	.SETS TYPE "'TYPE5'"
	.GOTO OKFILE !					File found ok
;
.NOFILE:.;
;
;                Source program 'DISK' 'UIC' 'PROG'.'TYPE'  not found ? ?
;
;
;  Supported source types are 
;                             .'TYPE1'   .'TYPE2'     .'TYPE3'  .'TYPE4'  .'TYPE5'
;                             .'TYPE1A'   .'TYPE1A'
;               For compilers
;                              'COMP1'    'COMP2'    'COMP3'   'COMP4'   'COMP5'
;
	.GOTO END
.OKFILE:.;
	.IFT BAT .GOTO BATCH !				Batch mode requested
	.;
	.;           O p e n   t h e   s o u r c e   f i l e
	.;
	.OPENR #0 'DISK''UIC''PROG'.'TYPE'
	.;
	.;
.COMLIN:.;
	.;
	.; C h e c k   f o r   c o m p i l e   l i n e   w h i c h   m u s t
	.;     b e g i n   w i t h   a   c o m p i l e r   n a m e ,   o r
	.;                      a   M C R   c o m m a n d .
	.;
	.READ #0 RECORD !				Read from source file
	.IFT <EOF> .GOTO NOINS !			Check for end of file
	.INC LCNT !					Bump line counter
	.;
	.PARSE RECORD "	" WORD1 WORD2 !			Parse out words (tab)
	.IF WORD2 EQ "" .PARSE RECORD " " WORD1 WORD2 !	Parse out words (space)
	.;
	.SETS COM WORD1[2:2] !				2nd character of WORD1
	.;
	.IF COM EQ "-" .GOTO COMLIN !			It's a - do not use
	.;						instruction but go back 
	.;						and check for more.
	.;
	.PARSE WORD2 " " WORD1 WORD2 !			WORD1 may contain FOR
	.;						MAC MCR etc
	.;						WORD2 will contain 
	.;						balance of line
	.;
	.IF WORD1 EQ "SUBROUTINE" .SETT SUB !		Set to indicate that
	.;						we processing a
	.;						subroutine 
	.;						( do not task build )
	.;
	.IF WORD1 EQ IPP .SETT SUB !			Tread IND like .sub
	.;
	.IF WORD1 EQ 'COMP1' .GOTO GOTCOM !		We have a compiler line
	.IF WORD1 EQ 'COMP2' .GOTO GOTCOM !		We have a compiler line
	.IF WORD1 EQ 'COMP3' .GOTO GOTCOM !		We have a compiler line
	.IF WORD1 EQ 'COMP4' .GOTO GOTCOM !		We have a compiler line
	.IF WORD1 EQ 'COMP5' .GOTO GOTCOM !		We have a compiler line
	.;
	.IF LCNT GT MAX .GOTO NOINS
	.;
	.;		L o o k   f o r   a   M C R   c o m m a n d
	.;
	.IF WORD1 NE "MCR" .GOTO COMLIN !		Not a command for MCR
	.;
	.; 						We have a command for
	.;						MCR. Issue it.
	.IFF MCR .GOTO COMLIN !				No MCR requested
	.;
	'WORD2'
	.SETN LCNT 0 !					Reset line counter
	.GOTO COMLIN !					Back for more.
	.;
	.;  S u b m i t   c o m m a n d   l i n e   t o   c o m p i l e r
	.;
.GOTCOM:.PARSE WORD2 "=" JUNK SORSWI !			Get source name and any
	.;						switches
	.IFT LSTYES .GOTO LSTYES
	.IFF LISTNO .GOTO COMPIL
	.GOTO NL'WORD1'
	.;						Option NOLIST is true
	.;						branch to the compiler
	.;						specific code and only
	.;						produce a .OBJ
	.;
.NLFOR:	.;						No list for FOR
	.PARSE WORD2 "," OBJ !				Strip out the .OBJ name.
	;						'<TIME>' Ext>.'TYPE' Cmp>'WORD1'
	'WORD1' 'OBJ',NL:='SORSWI'
	.GOTO COMSTA !					Check status of compiler
	.;
.NLF77:	.;						No list for F77
	.PARSE WORD2 "," OBJ !				Strip out the .OBJ name.
	;						'<TIME>' Ext>.'TYPE' Cmp>'WORD1'
	'WORD1' 'OBJ',NL:='SORSWI'
	.GOTO COMSTA !					Check status of compiler
	.;
.NLXCC: .;						No list for C
	;						'<TIME>' Ext>.'TYPE' Cmp>'WORD1'
	'WORD1' 'WORD2'
	.GOTO COMSTA !					Check status of compiler
.NLMAC:	.;						No list for MAC
	.PARSE WORD2 "," OBJ !				Strip out the .OBJ name.
	;						'<TIME>' Ext>.'TYPE' Cmp>'WORD1'
	'WORD1' 'OBJ',NL:='SORSWI'
	.GOTO COMSTA !					Check status of compiler
	.;
	.;
.NLIPP: .;						Can not have a NOLIST
	.;						with IPP
	.DISABLE QUIET
	;						NOLIST is invalid with .CMD
	.ENABLE QUIET
	.GOTO COMPIL

.LSTYES:.GOTO L'WORD1'
	.;						Option LSTYES is true
	.;						branch to the compiler
	.;						specific code
	.;
.LFOR:	.;						List for FOR
	.PARSE WORD2 "," OBJ !				Strip out the .OBJ name.
	;						'<TIME>' Ext>.'TYPE' Cmp>'WORD1'
	'WORD1' 'OBJ','OBJ'.LST='SORSWI'
	.GOTO COMSTA !					Check status of compiler
	.;
.LF77:	.;						List for F77
	.PARSE WORD2 "," OBJ !				Strip out the .OBJ name.
	;						'<TIME>' Ext>.'TYPE' Cmp>'WORD1'
	'WORD1' 'OBJ','OBJ'.LST='SORSWI'
	.GOTO COMSTA !					Check status of compiler
	.;
.LXCC: .;						No list for C
	;						'<TIME>' Ext>.'TYPE' Cmp>'WORD1'
	'WORD1' 'WORD2' !				Needs fixing. At the
	.;						present time I do not
	.;						have a C compiler
	.GOTO COMSTA !					Check status of compiler
.LMAC:	.;						No list for MAC
	.PARSE WORD2 "," OBJ !				Strip out the .OBJ name.
	;						'<TIME>' Ext>.'TYPE' Cmp>'WORD1'
	'WORD1' 'OBJ','OBJ'.LST='SORSWI'
	.GOTO COMSTA !					Check status of compiler
	.;
	.;
.LIPP: .;						Can not have a LIST
	.;						with IPP
	.DISABLE QUIET
	;						LIST is invalid with .CMD
	.ENABLE QUIET

.COMPIL:.;
	;						'<TIME>' Ext>.'TYPE' Cmp>'WORD1'
	'WORD1' 'WORD2'
.COMSTA:.;
	.SETN STATUS <EXSTAT> !				Capture exit status
	.;
	.; C h e c k   t h e   s t a t u s   o f   c o m p i l e r   f o r
	.;	   e r r o r s   i f   t r u e   s k i p   T K B 
	.;
	.IF <EXSTAT> EQ 1 .GOTO COMEND !		Compiled OK start 
	.;						TKB stuff
	.;
	.IF <EXSTAT> NE 0 .GOTO COMWAR !		Compiled with warnings
	.SETT COMWRN
;						'BOLD'Warnings reported by compiler 'ATTOFF'
	.;
	.GOTO COMLST
	.;
.COMWAR:.;
;						'BOLD'Errors reported by compiler 'ATTOFF'
	.;
.COMLST:.;
	.;
	.IFF ASKHIM .GOTO ERLIST !			NOASK is ineffect
	.;
	;
	.ASKS [0:15::1M] LISTD Enter terminal # for list of 'PROG'.'TYPE' (ie TI or SP to spool) 
	.;
	.IFT <EOF> .GOTO EXIT !			CNTRL-Z entered
	.IF LISTD EQ "" .GOTO ERLIST !		Nothing entered
	.IF LISTD EQ ".." .GOTO ERLIST !
	.;
	.PARSE LISTD ":" LISTD !			Drop the colon
	.SETS LISTD "'LISTD':" !			add back colon
	.IF LISTD EQ "SP:" .GOTO DEVOK !		Do not check SP: device
	.TEST LISTD
	.IF <STRLEN> LT 3 .GOTO DEVNO !			Must be at least 3
	.IF <STRLEN> GT 4 .GOTO DEVNO !			But not gt 4
	.;						char for testdevice
	.;
	.TESTDEVICE 'LISTD' !				Test listing device
	.PARSE <EXSTRI> "," JUNK DEVCHR JUNK !		  "	"	"
	.IF DEVCHR EQ "7" .GOTO DEVOK !			Looks ok
.DEVNO:	;
	;	The device 'BOLD''LISTD''ATTOFF' is invalid or not present in this system. Try again.
	.GOTO COMLST
.DEVOK:.;
	.SETS LSTDEV "'LISTD'" !			Set up listing device
	.IF LISTD EQ "SP:" .SETS LSTDEV "'PROG'.DMP" !	Spool listing file name
	.;
	;
	;	'BOLD'Listing TYPE ?'ATTOFF'        'BOLD'1'ATTOFF' = Errors only        'BOLD'2'ATTOFF' = Full listing
	;
	.ASKN [0:2:0:1M] LTYPE Enter list type for 'prog'.'type' (ie ti)    
	.;
	.IFT <EOF> .GOTO ERLIST !			CNTRL-Z entered
	.;
	.IF LTYPE EQ 0 .GOTO ERLIST !			Nothing entered
	.;
	.GOTO 'WORD1'ERR !				Branch to the compiler
	.;						specific code for
	.;						producing listing's
	.;						
.FORERR:.;						Fortran IV 
	.IF LTYPE EQ 1 .SETS ETYPE "0" !		Diagnostics only
	.IF LTYPE EQ 2 .SETS ETYPE "3" !		Source + Diagnostics
	'WORD1' ,'LSTDEV'/DI/LI:'ETYPE' = 'SORSWI'
	.GOTO ERLIST
.F77ERR:.;						Fortran 77
	.IF LTYPE EQ 1 .SETS ETYPE "0" !		Diagnostics only
	.IF LTYPE EQ 2 .SETS ETYPE "2" !		Source + Diagnostics
	.IF LISTD EQ "SP:" .SETS LSTDEV "'PROG'.DMP/SP" !	Add /SP
	'WORD1' ,'LSTDEV'/LI:'ETYPE' = 'SORSWI'
	.GOTO ERLIST
.XCCERR:.;						C compiler
	; Sorry, this is the only type of listing from the C compiler.
	.PARSE WORD2 " " WORD2 JUNK !			Strip out options
	.;						Compile to > list file
	.IF LISTD EQ "SP:" 'WORD1' 'WORD2' >'WORD2'.DMP
	.;						Dump to printer
	.IF LISTD EQ "SP:" PRINT 'WORD2'.DMP
	.;						Just compile
	.IF LISTD NE "SP:" 'WORD1' 'WORD2'
	.GOTO ERLIST
.MACERR:.;
	.IF LTYPE EQ 1 .SETS ETYPE "/NL" !		Diagnostics only
	.IF LTYPE EQ 2 .SETS ETYPE "/LI" !		Source + Diagnostics
	.IF LISTD EQ "SP:" .SETS LSTDEV "'PROG'.DMP/SP" !	Add /SP
	'WORD1' ,'LSTDEV''ETYPE' = 'SORSWI'	
	.GOTO ERLIST
	.;
.ERLIST:.IFF COMWRN .GOTO EXIT
	.;
	.;
	.IFF ASKHIM .GOTO COMEND !			No ask is in effect.
	.ASK [<FALSE>:1M] CONT 'BOLD'Continue Y/N >'ATTOFF' 
	.IFT <EOF> .GOTO EXIT !				End of file
	.;
	.IFF CONT .GOTO EXIT
	.;
.COMEND:.SETT COMOK !					Compile must be OK
	.IFT SUB .SETT TKBOK !				Subroutine. Set to 
	.;						indicate that TKB was 
	.;						OK even though it will
	.;						not be used
	.;
	.IFT SUB .GOTO SPECIA !				It's a subroutine
	.SETN LCNT 0 !					Reset line counter
	.;
	.;            O p e n  t h e   t e m p o r a r y   f i l e 
	.;                         X'PROG'.BLD
	.;                 f o r   t a s k   b u i l d i n g 
	.;
	.OPEN #1 'DISK''UIC''PROG'.BLD
	.;
	.;       R e a d   t h e   s o u r c e   c o d e   f o r   T K B 
	.;                     i n s t r u c t i o n s
	.;
.TKBSTA:.;
	.READ #0 RECORD
	.IFT <EOF> .GOTO NOINS !			End of file encountered
	.INC LCNT !					Bump the line counter
	.;
	.PARSE RECORD "	" WORD1 WORD2 !			Parse out words (tab)
	.IF WORD2 EQ "" .PARSE RECORD " " WORD1 WORD2 !	Parse out words (space)
	.;
	.;						Check the comment field 
	.;						if the 2nd position is
	.;						- do not include in
	.;						build file.
	.;
	.SETS COM WORD1[2:2]
	.;
	.IF COM EQ "-" .GOTO TKBSTA !			Instruction is
	.;						commented out.
	.;
	.;						Add to TKB file
	.DATA #1 'WORD2'
	.;						Add IDENT =
	.;						NOTE: The IDENT option
	.;						is added first, if the
	.;						source code contains
	.;						an IDENT option it will 
	.;						take precidence.
	.;
	.SETS SLASH WORD2[1:1]!				Parse
	.IF SLASH EQ "/" .DATA #1 IDENT = 'AIDENT'
	.;
	.;						Check options for a
	.;						task installed by a
	.;						name other than its own.
	.;
	.;						Get TKB options & values
	.PARSE WORD2 " " OPTION EQUAL VALUE !		Strip out spaces
	.SETS WORD2 "'OPTION''EQUAL''VALUE'" !		Put back together
	.PARSE WORD2 "	" OPTION EQUAL VALUE !		Strip out tabs
	.SETS WORD2 "'OPTION''EQUAL''VALUE'" !		Put back together
	.PARSE WORD2 "=" OPTION VALUE !			Finally get option/value
	.;
	.IF OPTION EQ "TASK" .SETS NAME "'VALUE'" ! 	Got a TASK = ?????? line
	.IF OPTION EQ "IDENT" .SETS AIDENT "'VALUE'" !	Got an ident line
	.;						modify AIDENT
	.SETS AIDENT AIDENT[1:6] !			Control size
	.;
	.;						Check for double slash
	.;						which indicates the
	.;						end of TKB instructions
	.;
	.IF LCNT GT MAX .GOTO NOINS !			To many lines read. Exit
	.IF WORD2 NE "//" .GOTO TKBSTA !		Go back for more.
	.CLOSE #1 !					Close the TKB file.
	.;
	.; Pass PROG.BLD to TKB
	.;
	;						'<TIME>' Id>'AIDENT' Name>'NAME'
	TKB @'DISK''UIC''PROG'.BLD
	.;
	.;      C h e c k   t h e   e x i t   s t a t u s   o f   T K B
	.;
	.SETN STATUS <EXSTAT> !				Capture exit status
	.IF <EXSTAT> NE 0 .GOTO TKBOK !			TKB reports warnings
	;
	;
;                Task builder reports warnings. Exit status = '<EXSTAT>' 
	;
	.GOTO TKBEND
.TKBOK:	.IF <EXSTAT> EQ 1 .GOTO TKBEND !		TKB reports success
	;
	;
;                    Task build failed using. Exit status = '<EXSTAT>' 
	;
;                 'PROG'.TSK Will not be removed , installed or purged.
	;
	.ENABLE QUIET
	.;						Dump out the build file
	'PIP' TI:='DISK''UIC''PROG'.BLD
	.DISABLE QUIET
	.GOTO EXIT !					TKB has failed. EXIT.
.TKBEND:.;
	.SETT TKBOK !					TKB ok
	.;
	.IFT INSOK .GOTO TKBCON
	.DISABLE QUIET
	.;
	.SETS TRPROG NAME[1:6] !			Make sure that the task 
	.;						name is only six 
	.;						characters then check
	.;						to see if the task is 
	.;						active.
	.;
	.IFACT 'TRPROG' ;						'BOLD''TRPROG''ATTOFF' is active  
	.;						TRPROG is PROG 
	.;						truncated to 6
	.;						characters. PROG is the
	.;						passed in or source file
	.;						name.
	.;
	.IFINS 'TRPROG' ;						'BOLD''TRPROG''ATTOFF' is installed 
	.;
	.IFNACT 'TRPROG' .AND .IFNINS 'TRPROG' .GOTO SPECIA ! Not installed or
	.;							active.
	.;
	;
	; The NOINS option has bypassed
	;			a) the check for an active task
	;			b) the check for an installed task
	;
	; The new task image will not be installed. Old versions will not be purged
	;
	.ENABLE QUIET
	.GOTO SPECIA !					Skip the checks for
	.;						for installed or active
	.;						tasks.
	.;
.TKBCON:.;						Check if the task is 
	.;						active. If it is we
	.;						will ask if the task
	.;						should be aborted
	.;						removed installed and
	.;						run. If the task is not
	.;						to be aborted we will
	.;						delete the new version
	.;						in order to protect
	.; 						the running copy.
	.;
	.SETS TRPROG NAME[1:6] !			Make sure that the task 
	.;						name is only six 
	.;						characters then check
	.;						to see if the task is 
	.;						active.
	.IFNACT 'TRPROG' .GOTO ACTNOT
	.SETS APROG "'TRPROG'" !			Program is active
	.SETT RUNING !						" "
.ACTIVE:
;
;	      The program 'PROG' is 'BOLD'ACTIVE ?'ATTOFF'    You have two choices 
;
;	A) ABORT REMOVE INSTALL and RUN program
;			or
;	B) Leave the current running version alone and delete the new .TSK
;
	.SETF ACT
	.IFT ASKHIM .ASK [<FALSE>:1M] ACT ABORT REMOVE INSTALL and RUN Y/N >
	.IFT ACT .GOTO ABORT
	.;
	.; Delete the new version.
	.;
;
;			'BOLD'The new 'PROG'.TSK is being deleted.'ATTOFF'
;
;	Your source code probably does not reflect the current task image.
;	This is your problem not mine. However your source has not been purged.
;
	.ENABLE QUIET !					Delete the new task
	.XQT 'PIP' 'PROG'.TSK;0/DE/NM
	.IFACT 'PIP' .WAIT 'PIP'
	.DISABLE QUIET
	.SETF TKBOK !					Disable the purge.
	.SETF RUNING !					Indicate that the task
	.;						is not active so that
	.;						it will not be re run.
	.GOTO EXIT
;
;		     ABORTING the task. It will be restarted.
;
.ABORT:.;
	ABORT 'APROG'
	.ENABLE QUIET !
	.DELAY 2S !					Just a sec or two
	.DISABLE QUIET !
.ACTNOT:.;
	.;
	.;
	.;     C h e c k   i f   t a s k   w a s   i n s t a l l e d   i f
	.;            t r u e  r e m o v e   a n d   r e i n s t a l l .
	.;
	.IFNINS 'NAME' .GOTO NINSEQ !			NAME is from a task=
	 REM 'NAME'
	.GOTO INSTAL
	.;
.NINSEQ:
	.IFNINS 'TRPROG' .GOTO SPECIA !			TRPROG is PROG 
	.;						truncated to 6
	.;						characters. PROG is the
	.;						passed in or source file
	.;						name.
	.;
	REM 'TRPROG'
	.;
.INSTAL:.;						Install
	INS 'DISK''UIC''PROG'
	.SETS NOTINS "   " !				Indicates is installled
	.;
	.DISABLE QUIET
	.;
.SPECIA:.; C h e c k  f o r   a n y   s p e c i a l    i n s t r u c t i o n 
	.; l i n e s .   T h e s e   a r e   M C R   c o m m a n d s   
	.; i n c l u d e d   i n   t h e   s o u r c e   f i l e
  	.; a s   a   c o m m e n t .
	.;
	.SETN LCNT 0 !					Reset line counter
	.;
	.IFF MCR .GOTO EXIT !				No MCR commands
	.;						requested
.NXTMCR:.;
	.READ #0 RECORD	
	.INC LCNT !					Increment line counter
	.IF LCNT GT MAX .GOTO MAXLIN !			Check for MAX lines read
	.;
	.PARSE RECORD "	" WORD1 WORD2 !			Parse out words (tab)
	.IF WORD2 EQ "" .PARSE RECORD " " WORD1 WORD2 !	Parse out words (space)
	.SETS COM WORD1[2:2] !				2nd character of WORD1
	.;
	.IF COM EQ "-" .GOTO NXTMCR ! 			It's a - do not use
	.;						instruction go back and
	.;						check for more.
	.;
	.PARSE WORD2 " " WORD1 WORD2 !			WORD1 may contain MCR 
	.;						WORD2 will contain
	.;						balance of line
	.;
	.IF WORD1 NE "MCR" .GOTO EXIT !			Not a command for MCR
	.;
	.; W e   h a v e   a   c o m m a n d   f o r   M C R .   I s s u e   i t
	.;
	'WORD2'	
	.GOTO NXTMCR !					Go back and check for 
	.;						more MCR commands.
	.;
.MAXLIN:.;
	;
	;
	;		Maximum line count ('MAX'). Has been exceeded.
	;
	.GOTO EXIT
.NOINS:
	;
	;
;         Failed to find CMP or TKB instructions in source program 'PROG' ?
	;
	.IF LCNT GE MAX ;		Maximum line count ('MAX'). Has been exceeded.
	;
.EXIT:	.IFF COMOK .SETF TKBOK !			Clean up and exit
	.ENABLE QUIET
	.;						Delete
	.IFT PIPOK .AND .IFF SUB .XQT 'PIP' 'DISK''UIC''PROG'.OBJ;*/DE/NM
	.IFACT 'PIP' .WAIT 'PIP'
	.IFT PIPOK .XQT 'PIP' 'DISK''UIC''PROG'.BLD;*/DE/NM,'PROG'.MAP;*
	.IFACT 'PIP' .WAIT 'PIP'
	.;						Purge
	.IFT TKBOK .AND .IFT PIPOK .AND .IFT INSOK .XQT 'PIP' 'DISK''UIC''PROG'.*/PU/NM
	.IFACT 'PIP' .WAIT 'PIP'
	.IFT RUNING RUN 'APROG'
	.;
	.CLOSE #0
	.CLOSE #1
	.;
	.IFT COMOK .AND .IFT TKBOK .GOTO ALLOK !
	.;
	;
	.DISABLE QUIET
;		TIE failed for 'DISK''UIC''PROG'.'TYPE' 
	.GOTO END
.ALLOK:	.DISABLE QUIET
	;						'<TIME>'	 'NOTINS' Installed
	;Tie complete for 'DISK''UIC''PROG'.'TYPE'
	.;
	.GOTO END
.INDERR:.DISABLE QUIET
;***************************************************************************
;             Submitted to DECUS
;
;             TIE exiting due to indirect command file error.  
;
;	      State of program 'DISK' 'UIC''PROG'.'TYPE' IS unknown
;
;	If you wish to have the problem corrected please send a copy of
;
;	A) TIE.CMD
;	B) Your source ( or just the TIE instructions portion )
;
;	on tape, at 1600 BPI via BRU or PIP.
;
;	To:
;			W. T. Dwyne
;			Systems Engineering
;			Stelco Steel
;			P.O. Box 2030
;			Hamilton, Ontario
;			Canada. L8N-3T1
;
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
.HELP:	HELP TIE

.END:	.DISABLE QUIET
	.;						Reset UIC
	.IFT CNAMED SET /NONAMED
	.IFF CHGUIC .GOTO NOU
	SET /DEF= 'ORGUIC'
	.;						Report change of uic
	;						'BOLD'Uic >'<DIRECT>' prot >'<UIC>''ATTOFF'
.NOU:	.ENABLE QUIET	
	.IF PIP NE "PIP" .IFINS 'PIP' REM 'PIP'

.EXIT STATUS

.BATCH:	.; 						Batch requested
	.; If you have accounting running you should parse out the account
	.; number from the accounting block, then use the account as the log
	.; account for this batch process.

	.TESTDEVICE TI: !				Test device TI:
	.PARSE <EXSTRI> "," PORT !			Parse out first
	.;						parameter which
	.;						will contain TTXX:
	.SETS P5 "NOASK"!				No ? in batch mode
	.OPEN #1 'DISK''UIC''PROG'.TAT !		Create the batch job

	.DATA #1 $JOB/TIME:5 [300,300]
	.DATA #1 $!
	.DATA #1 $! Batch job created by SY:TOOLS]TIE.CMD
	.DATA #1 $!                      Node: '<NETNOD>'
	.DATA #1 $!                      Date: '<DATE>' '<TIME>'
	.DATA #1 $!                      User: '<LOGDEV>' '<LOGUIC>'
	.DATA #1 $!                  From uic: '<DIRECT>' '<UIC>'
	.DATA #1 $!
	.IFT NAMED .DATA #1 $SET /NAMED !	Allow named directories
	.IFT NAMED .DATA #1 $SET /DEF='UIC' !	Change directory
	.DATA #1 $SET /UIC='<UIC>' !		Change protection
	.DATA #1 $SET NO ON
	.DATA #1 $!
	.DATA #1 $@SY:[TOOLS]TIE.CMD 'DISK''UIC''PROG'.'TYPE' 'P2' 'P3' 'P4' 'P5'
	.DATA #1 $!
	.DATA #1 $IF WARNING THEN GOTO WARERR
	.DATA #1 $IF ERROR THEN GOTO ERRERR
	.DATA #1 $IF SEVEREERROR THEN GOTO SEVERR
	.DATA #1 $!
	.DATA #1 $BRO 'PORT' Success TIE Complete for 'DISK''UIC''PROG'.'TYPE' 'P2' 'P3' 'P4' 'P5'
	.DATA #1 $SET NO ON
	.DATA #1 $PIP 'DISK''UIC''PROG'.TAT,.LOG/PU !	I do not /del in batch
	.DATA #1 $STOP
	.DATA #1 $!
	.DATA #1 $WARERR:
	.DATA #1 $BRO 'PORT' WARNING TIE Failed for 'DISK''UIC''PROG'.'TYPE' 'P2' 'P3' 'P4' 'P5'
	.DATA #1 $STOP
	.DATA #1 $!
	.DATA #1 $ERRERR:
	.DATA #1 $BRO 'PORT' ERROR TIE Failed for 'DISK''UIC''PROG'.'TYPE' 'P2' 'P3' 'P4' 'P5'
	.DATA #1 $STOP
	.DATA #1 $!
	.DATA #1 $SEVERR:
	.DATA #1 $BRO 'PORT' SEVEREERROR TIE Failed for 'DISK''UIC''PROG'.'TYPE' 'P2' 'P3' 'P4' 'P5'
	.DATA #1 $!
	.DATA #1 $EOJ
	.CLOSE #1 !					Close the TKB file.
	;
	;Tie submitting 'DISK''UIC''PROG'.'TYPE' to batch. Report status to 'PORT'
	SUBMIT /NOPRINT='DISK''UIC''PROG'.TAT
.STOP
